Index: trunk/libIGCM/libIGCM_sys/libIGCM_sys_cesium.ksh
===================================================================
--- trunk/libIGCM/libIGCM_sys/libIGCM_sys_cesium.ksh	(revision 663)
+++ trunk/libIGCM/libIGCM_sys/libIGCM_sys_cesium.ksh	(revision 664)
@@ -149,4 +149,7 @@
 #- Max number of arguments passed to nco operator or demigration command
 UNIX_MAX_LIMIT=360
+
+#- set PackDefault true on NEC front-end
+PackDefault=true
 
 #D-#==================================================
Index: trunk/libIGCM/libIGCM_sys/libIGCM_sys_curie.ksh
===================================================================
--- trunk/libIGCM/libIGCM_sys/libIGCM_sys_curie.ksh	(revision 663)
+++ trunk/libIGCM/libIGCM_sys/libIGCM_sys_curie.ksh	(revision 664)
@@ -191,4 +191,6 @@
 PackDefault=true
 
+#====================================================
+#- Number of core per node (max number of OpenMP task)
 NUM_COREPERNODE=8
 
@@ -1726,5 +1728,5 @@
       eval ExeNameOut=\${config_Executable_${comp}[1]}
 
-      if  [ "X${ExeNameOut}" != X\"\" ] ; then
+      if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${ExeNameOut}" != "Xinca.dat" ] ) ; then
         if ( ${OK_PARA_MPI} ) ; then
           eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
Index: trunk/libIGCM/libIGCM_sys/libIGCM_sys_default.ksh
===================================================================
--- trunk/libIGCM/libIGCM_sys/libIGCM_sys_default.ksh	(revision 663)
+++ trunk/libIGCM/libIGCM_sys/libIGCM_sys_default.ksh	(revision 664)
@@ -1,3 +1,3 @@
-#!/bin/ksh 
+#!/bin/ksh
 
 #**************************************************************
@@ -14,13 +14,13 @@
 #=========================================================
 # The documentation of this file can be automatically generated
-# if you use the prefix #D- for comments to be extracted. 
+# if you use the prefix #D- for comments to be extracted.
 # Extract with command: cat lib* | grep "^#D-" | cut -c "4-"
 #=========================================================
- 
+
 #D-#==================================================
 #D-LibIGCM_sys Default host
 #D-#==================================================
 #D-
-#D- This ksh library if a layer under some usefull 
+#D- This ksh library if a layer under some usefull
 #D- environment variables and shell commands.
 #D- All those definitions depend on host particularities.
@@ -62,5 +62,5 @@
 
 #=====================================================
-# Host and user names 
+# Host and user names
 # $hostname ou hostname
 typeset  HOST=${HOST:=$( hostname )}
@@ -76,8 +76,10 @@
 
 # rsync with path
-typeset -r RSYNC=/usr/bin/rsync  
+typeset -r RSYNC=/usr/bin/rsync
 #RSYNC_opt args to rsync
 typeset -r RSYNC_opt="-va"
 #"-Lt -v"
+# ie storage filesystem
+typeset -r STOREHOST=${MASTER}
 
 #====================================================
@@ -89,4 +91,12 @@
 # Host specific DIRECTORIES
 #====================================================
+
+#====================================================
+#- MirrorlibIGCM for frontend
+typeset -r MirrorlibIGCM=${MirrorlibIGCM:=false}
+
+#====================================================
+#- libIGCM_POST
+typeset -r libIGCM_POST=${libIGCM}
 
 #====================================================
@@ -95,8 +105,4 @@
 
 #====================================================
-#- libIGCM_POST
-typeset -r libIGCM_POST=${libIGCM}
-
-#====================================================
 #- SCRATCHDIR (=> ${R_DONNEES})
 typeset -r SCRATCHDIR=/tmp
@@ -107,6 +113,9 @@
 
 #====================================================
-#- ARCHIVE
+#- ARCHIVE (dedicated to large files)
 typeset -r ARCHIVE=/home/${LOGIN}
+
+#- ARCHIVE (dedicated to small/medium files)
+typeset -r STORAGE=${ARCHIVE}
 
 #====================================================
@@ -120,4 +129,16 @@
 
 #====================================================
+#- R_FIG (hosting figures : monitoring and atlas, and/or small files)
+typeset -r R_FIG=${STORAGE}/IGCM_OUT
+
+#====================================================
+#- R_BUF (ONLY FOR double copy an scratch)
+typeset -r R_BUF=${SCRATCHDIR}/IGCM_OUT
+
+#====================================================
+#- BIG_DIR : BIG_DIR to store files waiting for rebuild
+typeset -r BIG_DIR=${BIG_DIR:=${SCRATCHDIR}/REBUILD}
+
+#====================================================
 #- OUT_POST
 typeset -r R_OUT_POST=${R_OUT}
@@ -126,8 +147,4 @@
 #- RUN_DIR_PATH : Temporary working directory (=> TMP)
 typeset -r RUN_DIR_PATH=${RUN_DIR_PATH:=${SCRATCHDIR}/tmp$$}
-
-#====================================================
-#- BIG_DIR : BIG_DIR to store files waiting for rebuild
-typeset -r BIG_DIR=${BIG_DIR:=${SCRATCHDIR}/REBUILD}
 
 #====================================================
@@ -144,12 +161,29 @@
 UNIX_MAX_LIMIT=360
 
+#====================================================
+#- Number of core per node (max number of OpenMP task)
+NUM_COREPERNODE=1
+
+#====================================================
+#- Default number of MPI task for IPSL coupled model
+#- required for backward compatibility
+#-
+DEFAULT_NUM_PROC_OCE=1
+DEFAULT_NUM_PROC_CPL=1
+(( DEFAULT_NUM_PROC_ATM = BATCH_NUM_PROC_TOT - DEFAULT_NUM_PROC_OCE - DEFAULT_NUM_PROC_CPL ))
+DEFAULT_NUM_PROC_TOTAL=${BATCH_NUM_PROC_TOT}
+
 #D-#==================================================
 #D-function IGCM_sys_RshMaster
-#D-* Purpose: Master rsh command
+#D-* Purpose: Just a fake command to wrapp
+#D-           IGCM_card call in post-treatment
+#D-           Ulam do not see brodie filesystem
+#D-           Cesium do not see all mercure filesystem
+#D-           That's why we need this hack.
 #D-* Examples:
 #D-
 function IGCM_sys_RshMaster {
-    IGCM_debug_PushStack "IGCM_sys_RshMaster" $@
-    ssh ${HOST} /bin/ksh  <<-EOF
+  IGCM_debug_PushStack "IGCM_sys_RshMaster" $@
+  ssh ${HOST} /bin/ksh  <<-EOF
     export libIGCM=${libIGCM}
     export DEBUG_debug=${DEBUG_debug}
@@ -158,9 +192,9 @@
     ${@}
 EOF
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_RshMaster : erreur."
-	IGCM_debug_Exit "IGCM_sys_RshMaster"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_RshMaster"
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_RshMaster : erreur."
+    IGCM_debug_Exit "IGCM_sys_RshMaster"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_RshMaster"
 }
 
@@ -171,13 +205,13 @@
 #D-
 function IGCM_sys_RshArchive {
-    IGCM_debug_PushStack "IGCM_sys_RshArchive" $@
-    /bin/ksh  <<-EOF
+  IGCM_debug_PushStack "IGCM_sys_RshArchive" $@
+  /bin/ksh  <<-EOF
     ${@}
 EOF
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_RshArchive : erreur."
-	IGCM_debug_Exit "IGCM_sys_RshArchive"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_RshArchive"
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_RshArchive : erreur."
+    IGCM_debug_Exit "IGCM_sys_RshArchive"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_RshArchive"
 }
 
@@ -189,16 +223,16 @@
 (( RshPNum = 0 ))
 function IGCM_sys_RshPost {
-    IGCM_debug_PushStack "IGCM_sys_RshPost" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_RshPost :" $@
-    fi
-    #ssh ${HOST} exec /bin/ksh -vx $@ > out_RshPost.${RshPNum}
-    ssh ${HOST} exec /bin/ksh $@ > out_RshPost.${RshPNum}
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_RshPost : erreur."
-	IGCM_debug_Exit "IGCM_sys_RshPost"
-    fi
-    (( RshPNum = RshPNum + 1 ))
-    IGCM_debug_PopStack "IGCM_sys_RshPost"
+  IGCM_debug_PushStack "IGCM_sys_RshPost" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_RshPost :" $@
+  fi
+  #/bin/ksh -vx $@ > out_RshPost.${RshPNum}
+  ssh ${HOST} /bin/ksh $@ > out_RshPost.${RshPNum}
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_RshPost : erreur."
+    IGCM_debug_Exit "IGCM_sys_RshPost"
+  fi
+  (( RshPNum = RshPNum + 1 ))
+  IGCM_debug_PopStack "IGCM_sys_RshPost"
 }
 
@@ -209,15 +243,15 @@
 #D-
 function IGCM_sys_SendMail {
-    IGCM_debug_PushStack "IGCM_sys_SendMail" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_SendMail :" $@
-    fi
-
-    if ( ${ExitFlag} ) ; then
-	status=failed
-    else
-	status=completed
-    fi
-    cat  << END_MAIL > job_end.mail
+  IGCM_debug_PushStack "IGCM_sys_SendMail" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_SendMail :" $@
+  fi
+
+  if ( ${ExitFlag} ) ; then
+    status=failed
+  else
+    status=completed
+  fi
+  cat  << END_MAIL > job_end.mail
 Dear ${LOGIN},
 
@@ -229,15 +263,15 @@
 END_MAIL
 
-    if [ ! -z ${config_UserChoices_MailName} ] ; then
-	mailx -s "${config_UserChoices_JobName} ${status}" ${config_UserChoices_MailName} <  job_end.mail
-    elif [ -f ~/.forward ] ; then
-	mailx -s "${config_UserChoices_JobName} ${status}" $( cat ~/.forward ) < job_end.mail
-    fi
-
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_SendMail : erreur."
-	IGCM_debug_Exit "IGCM_sys_SendMail"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_SendMail"
+  if [ ! -z ${config_UserChoices_MailName} ] ; then
+    mailx -s "${config_UserChoices_JobName} ${status}" ${config_UserChoices_MailName} <  job_end.mail
+  elif [ -f ~/.forward ] ; then
+    mailx -s "${config_UserChoices_JobName} ${status}" $( cat ~/.forward ) < job_end.mail
+  fi
+
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_SendMail : erreur."
+    IGCM_debug_Exit "IGCM_sys_SendMail"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_SendMail"
 }
 
@@ -248,21 +282,21 @@
 #D-
 function IGCM_sys_Mkdir {
-    IGCM_debug_PushStack "IGCM_sys_Mkdir" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Mkdir :" $@
-    fi
-    if [ ! -d ${1} ]; then
-	\mkdir -p $1
-	if [ $? -gt 0 ] ; then
-	    echo "IGCM_sys_Mkdir : erreur."
-	    IGCM_debug_Exit "IGCM_sys_Mkdir"
-	fi
-    fi
+  IGCM_debug_PushStack "IGCM_sys_Mkdir" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Mkdir :" $@
+  fi
+  if [ ! -d ${1} ]; then
+    \mkdir -p $1
+    if [ $? -gt 0 ] ; then
+      echo "IGCM_sys_Mkdir : erreur."
+      IGCM_debug_Exit "IGCM_sys_Mkdir"
+    fi
+  fi
     # vérification :
-    if [ ! -d ${1} ] ; then
-	echo "IGCM_sys_Mkdir : erreur."
-	IGCM_debug_Exit "IGCM_sys_Mkdir"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Mkdir"
+  if [ ! -d ${1} ] ; then
+    echo "IGCM_sys_Mkdir : erreur."
+    IGCM_debug_Exit "IGCM_sys_Mkdir"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Mkdir"
 }
 
@@ -273,17 +307,17 @@
 #D-
 function IGCM_sys_MkdirArchive {
-    IGCM_debug_PushStack "IGCM_sys_MkdirArchive" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_MkdirArchive :" $@
-    fi
+  IGCM_debug_PushStack "IGCM_sys_MkdirArchive" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_MkdirArchive :" $@
+  fi
     #- creation de repertoire sur le serveur fichier
-    if [ ! -d ${1} ]; then 
-	\mkdir -p $1
-	if [ $? -gt 0 ] ; then
-	    echo "IGCM_sys_MkdirArchive : erreur."
-	    IGCM_debug_Exit "IGCM_sys_MkdirArchive"
-	fi
-    fi
-    IGCM_debug_PopStack "IGCM_sys_MkdirArchive"
+  if [ ! -d ${1} ]; then
+    \mkdir -p $1
+    if [ $? -gt 0 ] ; then
+      echo "IGCM_sys_MkdirArchive : erreur."
+      IGCM_debug_Exit "IGCM_sys_MkdirArchive"
+    fi
+  fi
+  IGCM_debug_PopStack "IGCM_sys_MkdirArchive"
 }
 
@@ -294,17 +328,17 @@
 #D-
 function IGCM_sys_MkdirWork {
-    IGCM_debug_PushStack "IGCM_sys_MkdirWork" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_MkdirWork :" $@
-    fi
+  IGCM_debug_PushStack "IGCM_sys_MkdirWork" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_MkdirWork :" $@
+  fi
     #- creation de repertoire sur le serveur fichier
-    if [ ! -d ${1} ]; then 
-	\mkdir -p $1
-	if [ $? -gt 0 ] ; then
-	    echo "IGCM_sys_MkdirWork : erreur."
-	    IGCM_debug_Exit "IGCM_sys_MkdirWork"
-	fi
-    fi
-    IGCM_debug_PopStack "IGCM_sys_MkdirWork"
+  if [ ! -d ${1} ]; then
+    \mkdir -p $1
+    if [ $? -gt 0 ] ; then
+      echo "IGCM_sys_MkdirWork : erreur."
+      IGCM_debug_Exit "IGCM_sys_MkdirWork"
+    fi
+  fi
+  IGCM_debug_PopStack "IGCM_sys_MkdirWork"
 }
 
@@ -315,14 +349,14 @@
 #D-
 function IGCM_sys_Cd {
-    IGCM_debug_PushStack "IGCM_sys_Cd" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Cd :" $@
-    fi
-    \cd $1
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_Cd : erreur."
-	IGCM_debug_Exit "IGCM_sys_Cd"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Cd"
+  IGCM_debug_PushStack "IGCM_sys_Cd" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Cd :" $@
+  fi
+  \cd $1
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_Cd : erreur."
+    IGCM_debug_Exit "IGCM_sys_Cd"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Cd"
 }
 
@@ -333,18 +367,18 @@
 #D-
 function IGCM_sys_Chmod {
-    IGCM_debug_PushStack "IGCM_sys_Chmod" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Chmod :" $@
-    fi
-    if [ $DRYRUN -le 1 ]; then
-	\chmod $@
-	if [ $? -gt 0 ] ; then
-	    echo "IGCM_sys_Chmod : erreur."
-	    IGCM_debug_Exit "IGCM_sys_Chmod"
-	fi
-    else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Chmod"
+  IGCM_debug_PushStack "IGCM_sys_Chmod" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Chmod :" $@
+  fi
+  if [ $DRYRUN -le 1 ]; then
+    \chmod $@
+    if [ $? -gt 0 ] ; then
+      echo "IGCM_sys_Chmod : erreur."
+      IGCM_debug_Exit "IGCM_sys_Chmod"
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Chmod"
 }
 
@@ -355,14 +389,14 @@
 #D-
 function IGCM_sys_FileSize {
-    IGCM_debug_PushStack "IGCM_sys_FileSize" $@
-
-    typeset sizeF
-    set +A sizeF -- $( ls -la ${1} )
-    if [ $? -gt 0 ] ; then
-	IGCM_debug_Exit "IGCM_sys_FileSize"
-    fi
-    eval ${2}=${sizeF[4]}
-
-    IGCM_debug_PopStack "IGCM_sys_FileSize"
+  IGCM_debug_PushStack "IGCM_sys_FileSize" $@
+
+  typeset sizeF
+  set +A sizeF -- $( ls -la ${1} )
+  if [ $? -gt 0 ] ; then
+    IGCM_debug_Exit "IGCM_sys_FileSize"
+  fi
+  eval ${2}=${sizeF[4]}
+
+  IGCM_debug_PopStack "IGCM_sys_FileSize"
 }
 
@@ -373,13 +407,13 @@
 #D-
 function IGCM_sys_TestDir {
-    IGCM_debug_PushStack "IGCM_sys_TestDir" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_TestDir :" $@
-    fi
-    typeset ExistFlag
-    ExistFlag=$( [ -d $1 ] && echo 0 || echo 1 )
-    IGCM_debug_PopStack "IGCM_sys_TestDir"
-
-    return ${ExistFlag}
+  IGCM_debug_PushStack "IGCM_sys_TestDir" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_TestDir :" $@
+  fi
+  typeset ExistFlag
+  ExistFlag=$( [ -d $1 ] && echo 0 || echo 1 )
+  IGCM_debug_PopStack "IGCM_sys_TestDir"
+
+  return ${ExistFlag}
 }
 
@@ -390,13 +424,13 @@
 #D-
 function IGCM_sys_TestDirArchive {
-    IGCM_debug_PushStack "IGCM_sys_TestDirArchive" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_TestDirArchive :" $@
-    fi
-    typeset ExistFlag
-    ExistFlag=$( [ -d $1 ] && echo 0 || echo 1 )
-    IGCM_debug_PopStack "IGCM_sys_TestDirArchive"
-
-    return ${ExistFlag}
+  IGCM_debug_PushStack "IGCM_sys_TestDirArchive" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_TestDirArchive :" $@
+  fi
+  typeset ExistFlag
+  ExistFlag=$( [ -d $1 ] && echo 0 || echo 1 )
+  IGCM_debug_PopStack "IGCM_sys_TestDirArchive"
+
+  return ${ExistFlag}
 }
 
@@ -407,10 +441,24 @@
 #D-
 function IGCM_sys_TestFileArchive {
-    IGCM_debug_PushStack "IGCM_sys_TestFileArchive" $@
-    typeset ExistFlag
-    ExistFlag=$( [ -f $1 ] && echo 0 || echo 1 )
-    IGCM_debug_PopStack "IGCM_sys_TestFileArchive"
-
-    return ${ExistFlag}
+  IGCM_debug_PushStack "IGCM_sys_TestFileArchive" $@
+  typeset ExistFlag
+  ExistFlag=$( [ -f $1 ] && echo 0 || echo 1 )
+  IGCM_debug_PopStack "IGCM_sys_TestFileArchive"
+
+  return ${ExistFlag}
+}
+
+#D-#==================================================
+#D-function IGCM_sys_TestFileBuffer
+#D-* Purpose: Test file that must NOT EXISTS on Buffer
+#D-* Examples:
+#D-
+function IGCM_sys_TestFileBuffer {
+  IGCM_debug_PushStack "IGCM_sys_TestFileBuffer" $@
+  typeset ExistFlag
+  ExistFlag=$( [ -f $1 ] && echo 0 || echo 1 )
+  IGCM_debug_PopStack "IGCM_sys_TestFileBuffer"
+
+  return ${ExistFlag}
 }
 
@@ -421,10 +469,24 @@
 #D-
 function IGCM_sys_CountFileArchive {
-    IGCM_debug_PushStack "IGCM_sys_CountFileArchive" $@
-    ls ${@} 2>/dev/null | wc -l
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_CountFileArchive : erreur."
-    fi
-    IGCM_debug_PopStack "IGCM_sys_CountFileArchive"
+  IGCM_debug_PushStack "IGCM_sys_CountFileArchive" $@
+  ls ${@} 2>/dev/null | wc -l
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_CountFileArchive : erreur."
+  fi
+  IGCM_debug_PopStack "IGCM_sys_CountFileArchive"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_CountFileBuffer
+#D-* Purpose: Count files on Scratch filesystem
+#D-* Examples:
+#D-
+function IGCM_sys_CountFileBuffer {
+  IGCM_debug_PushStack "IGCM_sys_CountFileBuffer" $@
+  ls ${@} 2>/dev/null | wc -l
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_CountFileBuffer : erreur."
+  fi
+  IGCM_debug_PopStack "IGCM_sys_CountFileBuffer"
 }
 
@@ -435,32 +497,31 @@
 #D-
 function IGCM_sys_Tree {
-    IGCM_debug_PushStack "IGCM_sys_Tree" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Tree :" $@
-    fi
-
-    \tree -f $@
-
-    IGCM_debug_PopStack "IGCM_sys_Tree"
+  IGCM_debug_PushStack "IGCM_sys_Tree" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Tree :" $@
+  fi
+
+  \tree -f $@
+
+  IGCM_debug_PopStack "IGCM_sys_Tree"
 }
 
 #D-#==================================================
 #D-function IGCM_sys_Tar
-#D-* Purpose: master un-tar command
+#D-* Purpose: master tar command
 #D-* Examples:
 #D-
 function IGCM_sys_Tar {
-    IGCM_debug_PushStack "IGCM_sys_Tar" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Tar :" $@
-    fi
-    \tar cvf $@
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_Tar : erreur."
-	IGCM_debug_Exit "IGCM_sys_Tar"
-    fi
-    \tar tvf $1
-
-    IGCM_debug_PopStack "IGCM_sys_Tar"
+  IGCM_debug_PushStack "IGCM_sys_Tar" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Tar :" $@
+  fi
+  \tar cf $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_Tar : erreur."
+    IGCM_debug_Exit "IGCM_sys_Tar"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_Tar"
 }
 
@@ -471,14 +532,14 @@
 #D-
 function IGCM_sys_UnTar {
-    IGCM_debug_PushStack "IGCM_sys_UnTar" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_UnTar :" $@
-    fi
-    \tar xvf $1
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_UnTar : erreur."
-	IGCM_debug_Exit "IGCM_sys_UnTar"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_UnTar"
+  IGCM_debug_PushStack "IGCM_sys_UnTar" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_UnTar :" $@
+  fi
+  \tar xvf $1
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_UnTar : erreur."
+    IGCM_debug_Exit "IGCM_sys_UnTar"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_UnTar"
 }
 
@@ -489,15 +550,15 @@
 #D-
 function IGCM_sys_Qsub {
-    IGCM_debug_PushStack "IGCM_sys_Qsub" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Qsub :" $@
-    fi
-    echo "ssh -l ${LOGIN} ${HOST} ""cd ${SUBMIT_DIR} ; ${@}"" > ${Script_Output} 2>&1 &"
-    ssh -l ${LOGIN} ${HOST} "cd ${SUBMIT_DIR} ; ${@}" > ${Script_Output} 2>&1 &
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_Qsub : erreur."
-	IGCM_debug_Exit "IGCM_sys_Qsub"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Qsub"
+  IGCM_debug_PushStack "IGCM_sys_Qsub" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Qsub :" $@
+  fi
+  echo "ssh -l ${LOGIN} ${HOST} ""cd ${SUBMIT_DIR} ; ${@}"" > ${Script_Output} 2>&1 &"
+  ssh -l ${LOGIN} ${HOST} "cd ${SUBMIT_DIR} ; ${@}" > ${Script_Output} 2>&1 &
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_Qsub : erreur."
+    IGCM_debug_Exit "IGCM_sys_Qsub"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Qsub"
 }
 
@@ -508,22 +569,22 @@
 #D-
 function IGCM_sys_QsubPost {
-    IGCM_debug_PushStack "IGCM_sys_QsubPost" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_QsubPost :" $@
-    fi
+  IGCM_debug_PushStack "IGCM_sys_QsubPost" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_QsubPost :" $@
+  fi
     #echo "ssh -x -l ${LOGIN} ${HOST} ${3} > ${2} 2>&1 &"
-    #    ssh -x -l ${LOGIN} ${HOST} 
-    echo "${libIGCM_POST}/$1.job > ${POST_DIR}/$1.${PeriodDateEnd}.out 2>&1 &"
-    ${libIGCM_POST}/$1.job > ${POST_DIR}/${Script_Post_Output}.out 2>&1 &
+    #    ssh -x -l ${LOGIN} ${HOST}
+  echo "${libIGCM_POST}/$1.job > ${POST_DIR}/$1.${PeriodDateEnd}.out 2>&1 &"
+  ${libIGCM_POST}/$1.job > ${POST_DIR}/${Script_Post_Output}.out 2>&1 &
     #    ${3} > ${2} 2>&1 &
-    if [ $? -gt 0 ] ; then
-	echo "IGCM_sys_QsubPost : erreur " $@
-	IGCM_debug_Exit "IGCM_sys_QsubPost"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_QsubPost"
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_QsubPost : erreur " $@
+    IGCM_debug_Exit "IGCM_sys_QsubPost"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_QsubPost"
 }
 
 #D-*************************
-#D- File transfer functions 
+#D- File transfer functions
 #D-*************************
 #D-
@@ -535,108 +596,108 @@
 #D-  Error values and explanations can depend on your system version.
 function IGCM_sys_Rsync_out {
-    RET=$1
-    if [ ! $RET ] ; then
-	echo "rsync error !"
-    fi
-
-    if [ $MYLANG = "fr" ]; then
-	case $RET in
-	    0)  return ;;
-	    1)  echo "Erreur de rsync ; RERR_SYNTAX : "
-		echo "Erreur de syntaxe ou d'utilisation."
-		return;;
-	    2)  echo "Erreur de rsync ; RERR_PROTOCOL : "
-		echo "Incompatibilité de protocole."
-		return;;
-	    3)  echo "Erreur de rsync ; RERR_FILESELECT 3"
-		echo "Erreurs  lors  de  la  sélection des fichiers d'entrée sortie et"
-		echo "répertoires"
-		return;;
-	    4)  echo "Erreur de rsync ; RERR_UNSUPPORTED"
-		echo "Action demandée non supportée : une tentative de manipulation de"
-		echo "fichiers  64-bits  sur une plate-forme qui ne les supporte pas a"
-		echo "été faite ; ou une option qui est supportée par le  client  mais"
-		echo "pas par le serveur a été spécifiée."
-		return;;
-	    10) echo "Erreur de rsync ; RERR_SOCKETIO"
-		echo "Erreur dans le socket d'entrée sortie"
-		return;;
-	    11) echo "Erreur de rsync ; RERR_FILEIO"
-		echo "Erreur d'entrée sortie fichier"
-		return;;
-	    12) echo "Erreur de rsync ; RERR_STREAMIO"
-		echo "Erreur dans flux de donnée du protocole rsync"
-		return;;
-	    13) echo "Erreur de rsync ; RERR_MESSAGEIO"
-		echo "Erreur avec les diagnostics du programme"
-		return;;
-	    14) echo "Erreur de rsync ; RERR_IPC"
-		echo "Erreur dans le code IPC"
-		return;;
-	    20) echo "Erreur de rsync ; RERR_SIGNAL"
-		echo "SIGUSR1 ou SIGINT reçu"
-		return;;
-	    21) echo "Erreur de rsync ; RERR_WAITCHILD"
-		echo "Une erreur retournée par waitpid()"
-		return;;
-	    22) echo "Erreur de rsync ; RERR_MALLOC"
-		echo "Erreur lors de l'allocation des tampons de mémoire de coeur"
-		return;;
-	    23) echo ""
-                echo "Erreur fichier inexistant"
-		return;;
-	    30) echo "Erreur de rsync ; RERR_TIMEOUT"
-		echo "Temps d'attente écoulé dans l'envoi/réception de données"
-		return;;
-	    *)  echo "Erreur de rsync : code de retour de rsync inconnu :" $RET
-		return;;
-	esac
-    elif [ $MYLANG = "en" ] ; then
-	case $RET in
-	    0)  return;;		
-	    1)  echo "rsync error : Syntax or usage error "
-		return;;
-	    2)  echo "rsync error : Protocol incompatibility "
-		return;;
-	    3)  echo "rsync error : Errors selecting input/output files, dirs"
-		return;;
-	    4)  echo "rsync error : Requested action not supported: an attempt"
-		echo "was made to manipulate 64-bit files on a platform that cannot support"
-		echo "them; or an option was specified that is supported by the client and"
-		echo "not by the server."
-		return;;
-	    5)  echo "rsync error : Error starting client-server protocol"
-		return;;
-	    10) echo "rsync error : Error in socket I/O "
-		return;;
-	    11) echo "rsync error : Error in file I/O "
-		return;;
-	    12) echo "rsync error : Error in rsync protocol data stream "
-		return;;
-	    13) echo "rsync error : Errors with program diagnostics "
-		return;;
-	    14) echo "rsync error : Error in IPC code "
-		return;;
-	    20) echo "rsync error : Received SIGUSR1 or SIGINT "
-		return;;
-	    21) echo "rsync error : Some error returned by waitpid() "
-		return;;
-	    22) echo "rsync error : Error allocating core memory buffers "
-		return;;
-	    23) echo "rsync error : Partial transfer due to error"
-		return;;
-	    24) echo "rsync error : Partial transfer due to vanished source files"
-		return;;
-	    30) echo "rsync error : Timeout in data send/receive "
-		return;;
-	    *)  echo "rsync error : return code of rsync unknown :" $RET
-		return;;
-	esac
-    else
-	echo "unknown language $MYLANG."
-	return
-    fi
-}
-    
+  RET=$1
+  if [ ! $RET ] ; then
+    echo "rsync error !"
+  fi
+
+  if [ $MYLANG = "fr" ]; then
+    case $RET in
+    0)  return ;;
+    1)  echo "Erreur de rsync ; RERR_SYNTAX : "
+      echo "Erreur de syntaxe ou d'utilisation."
+      return;;
+    2)  echo "Erreur de rsync ; RERR_PROTOCOL : "
+      echo "Incompatibilité de protocole."
+      return;;
+    3)  echo "Erreur de rsync ; RERR_FILESELECT 3"
+      echo "Erreurs  lors  de  la  sélection des fichiers d'entrée sortie et"
+      echo "répertoires"
+      return;;
+    4)  echo "Erreur de rsync ; RERR_UNSUPPORTED"
+      echo "Action demandée non supportée : une tentative de manipulation de"
+      echo "fichiers  64-bits  sur une plate-forme qui ne les supporte pas a"
+      echo "été faite ; ou une option qui est supportée par le  client  mais"
+      echo "pas par le serveur a été spécifiée."
+      return;;
+    10) echo "Erreur de rsync ; RERR_SOCKETIO"
+      echo "Erreur dans le socket d'entrée sortie"
+      return;;
+    11) echo "Erreur de rsync ; RERR_FILEIO"
+      echo "Erreur d'entrée sortie fichier"
+      return;;
+    12) echo "Erreur de rsync ; RERR_STREAMIO"
+      echo "Erreur dans flux de donnée du protocole rsync"
+      return;;
+    13) echo "Erreur de rsync ; RERR_MESSAGEIO"
+      echo "Erreur avec les diagnostics du programme"
+      return;;
+    14) echo "Erreur de rsync ; RERR_IPC"
+      echo "Erreur dans le code IPC"
+      return;;
+    20) echo "Erreur de rsync ; RERR_SIGNAL"
+      echo "SIGUSR1 ou SIGINT reçu"
+      return;;
+    21) echo "Erreur de rsync ; RERR_WAITCHILD"
+      echo "Une erreur retournée par waitpid()"
+      return;;
+    22) echo "Erreur de rsync ; RERR_MALLOC"
+      echo "Erreur lors de l'allocation des tampons de mémoire de coeur"
+      return;;
+    23) echo ""
+      echo "Erreur fichier inexistant"
+      return;;
+    30) echo "Erreur de rsync ; RERR_TIMEOUT"
+      echo "Temps d'attente écoulé dans l'envoi/réception de données"
+      return;;
+    *)  echo "Erreur de rsync : code de retour de rsync inconnu :" $RET
+      return;;
+    esac
+  elif [ $MYLANG = "en" ] ; then
+    case $RET in
+    0)  return;;
+    1)  echo "rsync error : Syntax or usage error "
+      return;;
+    2)  echo "rsync error : Protocol incompatibility "
+      return;;
+    3)  echo "rsync error : Errors selecting input/output files, dirs"
+      return;;
+    4)  echo "rsync error : Requested action not supported: an attempt"
+      echo "was made to manipulate 64-bit files on a platform that cannot support"
+      echo "them; or an option was specified that is supported by the client and"
+      echo "not by the server."
+      return;;
+    5)  echo "rsync error : Error starting client-server protocol"
+      return;;
+    10) echo "rsync error : Error in socket I/O "
+      return;;
+    11) echo "rsync error : Error in file I/O "
+      return;;
+    12) echo "rsync error : Error in rsync protocol data stream "
+      return;;
+    13) echo "rsync error : Errors with program diagnostics "
+      return;;
+    14) echo "rsync error : Error in IPC code "
+      return;;
+    20) echo "rsync error : Received SIGUSR1 or SIGINT "
+      return;;
+    21) echo "rsync error : Some error returned by waitpid() "
+      return;;
+    22) echo "rsync error : Error allocating core memory buffers "
+      return;;
+    23) echo "rsync error : Partial transfer due to error"
+      return;;
+    24) echo "rsync error : Partial transfer due to vanished source files"
+      return;;
+    30) echo "rsync error : Timeout in data send/receive "
+      return;;
+    *)  echo "rsync error : return code of rsync unknown :" $RET
+      return;;
+    esac
+  else
+    echo "unknown language $MYLANG."
+    return
+  fi
+}
+
 #D-#==================================================
 #D-function IGCM_sys_Cp
@@ -645,24 +706,24 @@
 #D-
 function IGCM_sys_Cp {
-    IGCM_debug_PushStack "IGCM_sys_Cp" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Cp :" $@
-    fi
-
-    typeset RET
-
-    echo cp --preserve=timestamps $@ > out_rsync 2>&1
-    \cp --preserve=timestamps $@ >> out_rsync 2>&1
-    RET=$?
-    
-    if [ ${RET} -gt 0 ] ; then
-	 echo ""
-# 	echo "IGCM_sys_Cp : error."
-# 	cat out_rsync
-# 	IGCM_debug_Exit "IGCM_sys_Cp"
-     else
-	 \rm out_rsync
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Cp"
+  IGCM_debug_PushStack "IGCM_sys_Cp" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Cp :" $@
+  fi
+
+  typeset RET
+
+  echo cp --preserve=timestamps $@ > out_rsync 2>&1
+  \cp --preserve=timestamps $@ >> out_rsync 2>&1
+  RET=$?
+
+  if [ ${RET} -gt 0 ] ; then
+    echo ""
+#       echo "IGCM_sys_Cp : error."
+#       cat out_rsync
+#       IGCM_debug_Exit "IGCM_sys_Cp"
+  else
+    \rm out_rsync
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Cp"
 }
 
@@ -673,23 +734,23 @@
 #D-
 function IGCM_sys_Rm {
-    IGCM_debug_PushStack "IGCM_sys_Rm" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Rm :" $@
-    fi
-
-    typeset RET
-
-    echo rm $@ > out_rsync 2>&1
-    \rm $@ >> out_rsync 2>&1
-    RET=$?
-    
-    if [ ${RET} -gt 0 ] ; then
-	echo "IGCM_sys_Rm : error."
-	cat out_rsync
-	IGCM_debug_Exit "IGCM_sys_Rm"
-    else
-	\rm out_rsync
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Rm"
+  IGCM_debug_PushStack "IGCM_sys_Rm" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Rm :" $@
+  fi
+
+  typeset RET
+
+  echo rm $@ > out_rsync 2>&1
+  \rm $@ >> out_rsync 2>&1
+  RET=$?
+
+  if [ ${RET} -gt 0 ] ; then
+    echo "IGCM_sys_Rm : error."
+    cat out_rsync
+    IGCM_debug_Exit "IGCM_sys_Rm"
+  else
+    \rm out_rsync
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Rm"
 }
 
@@ -701,11 +762,11 @@
 #D-
 function IGCM_sys_RmRunDir {
-    IGCM_debug_PushStack "IGCM_sys_RmRunDir" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_RmRunDir :" $@
-	echo "Dummy call, let the scheduler do that."
+  IGCM_debug_PushStack "IGCM_sys_RmRunDir" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_RmRunDir :" $@
+    echo "Dummy call, let the scheduler do that."
 #	IGCM_sys_Rm -rf ${RUN_DIR}
-    fi
-    IGCM_debug_PopStack "IGCM_sys_RmRunDir"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_RmRunDir"
 }
 
@@ -716,29 +777,29 @@
 #D-
 function IGCM_sys_Mv {
-    IGCM_debug_PushStack "IGCM_sys_Mv" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Mv :" $@
-    fi
-
-    if [ $DRYRUN = 0 ]; then
-
-        typeset RET
-            
-        echo mv $@ > out_rsync 2>&1
-        \mv $@ >> out_rsync 2>&1
-        RET=$?
-    
-        if [ ${RET} -gt 0 ] ; then
-            echo "IGCM_sys_Mv : error in mv."
-            cat out_rsync
-            IGCM_debug_Exit "IGCM_sys_Mv"
-	else
-	    \rm out_rsync
-	fi
+  IGCM_debug_PushStack "IGCM_sys_Mv" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Mv :" $@
+  fi
+
+  if [ $DRYRUN = 0 ]; then
+
+    typeset RET
+
+    echo mv $@ > out_rsync 2>&1
+    \mv $@ >> out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Mv : error in mv."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_Mv"
     else
-        ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_Mv"
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_Mv"
 }
 
@@ -749,35 +810,35 @@
 #D-
 function IGCM_sys_Put_Dir {
-    IGCM_debug_PushStack "IGCM_sys_Put_Dir" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Put_Dir :" $@
-    fi
-    if [ $DRYRUN = 0 ]; then
-	if [ ! -d ${1} ] ; then
-	    echo "WARNING : IGCM_sys_Put_Dir ${1} DOES NOT EXIST ."
-	    IGCM_debug_PopStack "IGCM_sys_Put_Dir"
-	    return
-	fi
-
-	typeset RET
-
-	# Only if we use rsync
-	#IGCM_sys_TestDirArchive $( dirname $2 )
-	#
-	#USUAL WAY
-	\cp -R $1 $2 > out_rsync 2>&1
-  	RET=$?
-
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Put_Dir : error."
-	    cat out_rsync
-	    IGCM_debug_Exit "IGCM_sys_Put_Dir"
-	else
-	    \rm out_rsync
-	fi
+  IGCM_debug_PushStack "IGCM_sys_Put_Dir" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Put_Dir :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+    if [ ! -d ${1} ] ; then
+      echo "WARNING : IGCM_sys_Put_Dir ${1} DOES NOT EXIST ."
+      IGCM_debug_PopStack "IGCM_sys_Put_Dir"
+      return
+    fi
+
+    typeset RET
+
+        # Only if we use rsync
+        #IGCM_sys_TestDirArchive $( dirname $2 )
+        #
+        #USUAL WAY
+    \cp -R $1 $2 > out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Put_Dir : error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_Put_Dir"
     else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Put_Dir"
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Put_Dir"
 }
 
@@ -788,32 +849,32 @@
 #D-
 function IGCM_sys_Get_Dir {
-    IGCM_debug_PushStack "IGCM_sys_Get_Dir" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Get_Dir :" $@
-    fi
-    if [ $DRYRUN = 0 ]; then
-	if [ ! -d ${1} ] ; then
-	    echo "WARNING : IGCM_sys_Get_Dir ${1} DOES NOT EXIST ."
-	    IGCM_debug_PopStack "IGCM_sys_Get_Dir"
-	    return
-	fi
-
-	typeset RET
-
-	#USUAL WAY
-	\cp -R $1 $2 > out_rsync 2>&1
-  	RET=$?
-
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Get_Dir : error."
-	    cat out_rsync
-	    IGCM_debug_Exit "IGCM_sys_Get_Dir"
-	else
-	    \rm out_rsync
-	fi
+  IGCM_debug_PushStack "IGCM_sys_Get_Dir" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Get_Dir :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+    if [ ! -d ${1} ] ; then
+      echo "WARNING : IGCM_sys_Get_Dir ${1} DOES NOT EXIST ."
+      IGCM_debug_PopStack "IGCM_sys_Get_Dir"
+      return
+    fi
+
+    typeset RET
+
+        #USUAL WAY
+    \cp -R $1 $2 > out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Get_Dir : error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_Get_Dir"
     else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Get_Dir"
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Get_Dir"
 }
 
@@ -824,32 +885,32 @@
 #D-
 function IGCM_sys_Get_Master {
-    IGCM_debug_PushStack "IGCM_sys_Get_Master" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Get_Master :" $@
-    fi
-    if [ $DRYRUN = 0 ]; then
-        if ( [ ! -d ${1} ] && [ ! -f ${1} ] ) ; then
-	    echo "WARNING : IGCM_sys_Get_Master ${1} DOES NOT EXIST ."
-	    IGCM_debug_PopStack "IGCM_sys_Get_Master"
-	    return
-	fi
-
-	typeset RET
-
-	#USUAL WAY
-	cp -R $1 $2 > out_rsync 2>&1
-  	RET=$?
-
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Get_Master : error."
-	    cat out_rsync
-	    IGCM_debug_Exit "IGCM_sys_Get_Master"
-	else
-	    \rm out_rsync
-	fi
+  IGCM_debug_PushStack "IGCM_sys_Get_Master" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Get_Master :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+    if ( [ ! -d ${1} ] && [ ! -f ${1} ] ) ; then
+      echo "WARNING : IGCM_sys_Get_Master ${1} DOES NOT EXIST ."
+      IGCM_debug_PopStack "IGCM_sys_Get_Master"
+      return
+    fi
+
+    typeset RET
+
+        #USUAL WAY
+    cp -R $1 $2 > out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Get_Master : error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_Get_Master"
     else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Get_Master"
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Get_Master"
 }
 
@@ -861,41 +922,82 @@
 #D-
 function IGCM_sys_Put_Rest {
-    IGCM_debug_PushStack "IGCM_sys_Put_Rest" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Put_Rest :" $@
-    fi
-    if [ $DRYRUN = 0 ]; then
-
-	IGCM_sys_TestDirArchive $( dirname $2 )
-
-	if [ ! -f ${1} ] ; then
-	    echo "ERROR : IGCM_sys_Put_Rest ${1} DOES NOT EXIST ."
-	    IGCM_debug_Exit "IGCM_sys_Put_Rest"
-	fi
-	if [ X${JobType} = XRUN ] ; then
-	    IGCM_sys_Chmod 444 ${1}
-	fi
-
-	typeset RET
-
-	echo ${RSYNC} ${RSYNC_opt} $1 $2 > out_rsync 2>&1
-	${RSYNC} ${RSYNC_opt} $1 $2 >> out_rsync 2>&1
-	RET=$?
-	IGCM_sys_Rsync_out $RET
-
-	${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
-	(( RET=RET+$? ))
-
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Put_Rest : error."
-	    cat out_rsync
-	    IGCM_debug_Exit "IGCM_sys_Put_Rest"
-	else
-	    \rm out_rsync
-	fi
+  IGCM_debug_PushStack "IGCM_sys_Put_Rest" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Put_Rest :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+
+    IGCM_sys_TestDirArchive $( dirname $2 )
+
+    if [ ! -f ${1} ] ; then
+      echo "ERROR : IGCM_sys_Put_Rest ${1} DOES NOT EXIST ."
+      IGCM_debug_Exit "IGCM_sys_Put_Rest"
+    fi
+    if [ X${JobType} = XRUN ] ; then
+      IGCM_sys_Chmod 444 ${1}
+    fi
+
+    typeset RET
+
+    echo ${RSYNC} ${RSYNC_opt} $1 $2 > out_rsync 2>&1
+    ${RSYNC} ${RSYNC_opt} $1 $2 >> out_rsync 2>&1
+    RET=$?
+    IGCM_sys_Rsync_out $RET
+
+    ${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
+    (( RET=RET+$? ))
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Put_Rest : error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_Put_Rest"
     else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Put_Rest"
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Put_Rest"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_PutBuffer_Rest
+#D-* Purpose: Put computied restarts on ${SCRATCHDIR}.
+#D-           File and target directory must exist.
+#D-* Examples:
+#D-
+function IGCM_sys_PutBuffer_Rest {
+  IGCM_debug_PushStack "IGCM_sys_PutBuffer_Rest" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_PutBuffer_Rest :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+    if [ ! -f ${1} ] ; then
+      echo "ERROR : IGCM_sys_PutBuffer_Rest ${1} DOES NOT EXIST ."
+      IGCM_debug_Exit "IGCM_sys_PutBuffer_Rest"
+    fi
+
+    typeset RET
+    #
+    if [ X${JobType} = XRUN ] ; then
+      IGCM_sys_Chmod 444 ${1}
+    fi
+
+    #
+    # USUAL WAY
+    \cp $1 $2 > out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_PutBuffer_Rest : error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_PutBuffer_Rest"
+    else
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_PutBuffer_Rest"
 }
 
@@ -906,48 +1008,93 @@
 #D-
 function IGCM_sys_Put_Out {
-    IGCM_debug_PushStack "IGCM_sys_Put_Out" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Put_Out :" $@
-    fi
-    if [ $DRYRUN = 0 ]; then
-	if [ -f ${1} ] ; then
-	    if [ ! -d $( dirname $2 ) ] ; then
-		IGCM_sys_MkdirArchive $( dirname $2 )
-	    fi
-	else
-	    echo "WARNING : IGCM_sys_Put_Out ${1} DOES NOT EXIST ."
-	    IGCM_debug_PopStack "IGCM_sys_Put_Out"
-	    return 1
-	fi
-
-	typeset RET
-	#
-	if [ X${JobType} = XRUN ] ; then
-	    if [ X${3} = X ] ; then
-		IGCM_sys_Chmod 444 ${1}
-	    fi
-	fi
-	#
-
-	echo ${RSYNC} ${RSYNC_opt} $1 $2 > out_rsync 2>&1
-	${RSYNC} ${RSYNC_opt} $1 $2 >> out_rsync 2>&1
-	RET=$?
-	IGCM_sys_Rsync_out $RET
-
-	${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
-	(( RET=RET+$? ))
-
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Put_Out : error."
-	    cat out_rsync
-	    IGCM_debug_Exit "IGCM_sys_Put_Out"
-	else
-	    \rm out_rsync
-	fi
+  IGCM_debug_PushStack "IGCM_sys_Put_Out" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Put_Out :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+    if [ -f ${1} ] ; then
+      if [ ! -d $( dirname $2 ) ] ; then
+        IGCM_sys_MkdirArchive $( dirname $2 )
+      fi
     else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Put_Out"
-    return 0
+      echo "WARNING : IGCM_sys_Put_Out ${1} DOES NOT EXIST ."
+      IGCM_debug_PopStack "IGCM_sys_Put_Out"
+      return 1
+    fi
+
+    typeset RET
+        #
+    if [ X${JobType} = XRUN ] ; then
+      if [ X${3} = X ] ; then
+        IGCM_sys_Chmod 444 ${1}
+      fi
+    fi
+        #
+
+    echo ${RSYNC} ${RSYNC_opt} $1 $2 > out_rsync 2>&1
+    ${RSYNC} ${RSYNC_opt} $1 $2 >> out_rsync 2>&1
+    RET=$?
+    IGCM_sys_Rsync_out $RET
+
+    ${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
+    (( RET=RET+$? ))
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Put_Out : error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_Put_Out"
+    else
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Put_Out"
+  return 0
+}
+
+#D-#==================================================
+#D-function IGCM_sys_PutBuffer_Out
+#D-* Purpose: Copy a file on ${SCRATCHDIR} after having chmod it in readonly
+#D-* Examples:
+#D-
+function IGCM_sys_PutBuffer_Out {
+  IGCM_debug_PushStack "IGCM_sys_PutBuffer_Out" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_PutBuffer_Out :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+    if [ ! -f ${1} ] ; then
+      echo "WARNING : IGCM_sys_PutBuffer_Out ${1} DOES NOT EXIST ."
+      IGCM_debug_PopStack "IGCM_sys_PutBuffer_Out"
+      return 1
+    fi
+    #
+    IGCM_sys_Mkdir $( dirname $2 )
+    #
+    typeset RET
+
+    if [ X${JobType} = XRUN ] ; then
+      if [ X${3} = X ] ; then
+        IGCM_sys_Chmod 444 ${1}
+      fi
+    fi
+    #
+    # USUAL WAY
+    \cp $1 $2 > out_rsync 2>&1
+    RET=$?
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_PutBuffer_Out : error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_PutBuffer_Out"
+    else
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_PutBuffer_Out"
+  return 0
 }
 
@@ -958,54 +1105,137 @@
 #D-            IGCM_sys_Get /l Array_contain_myfiles /destpath/
 function IGCM_sys_Get {
-    IGCM_debug_PushStack "IGCM_sys_Get" $@
-
-    typeset DEST RET dm_liste ifile target
-
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Get :" $@
-    fi
-    if [ $DRYRUN -le 2 ]; then
-	if [ X${1} = X'/l' ] ; then
+  IGCM_debug_PushStack "IGCM_sys_Get" $@
+
+  typeset DEST RET dm_liste ifile target
+
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Get :" $@
+  fi
+  if [ $DRYRUN -le 2 ]; then
+    if [ X${1} = X'/l' ] ; then
             # test if the first file is present in the old computation :
-	    eval set +A dm_liste \${${2}}
-	else
-	    dm_liste=${1}
-	fi
-	eval DEST=\${${#}}
-
-	# test if the (first) file is present in the old computation :
-	IGCM_sys_TestFileArchive ${dm_liste[0]}
-	RET=$?
-        if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Get, ERROR : regular file ${dm_liste[0]} DOES NOT EXIST ."
-	    IGCM_debug_Exit "IGCM_sys_Get"
-	    #return
-	fi
-
-	(( RET=0 ))
-        for target in ${dm_liste[*]} ; do
-	  \cp ${target} ${DEST} >> out_rsync 2>&1
-          (( RET=RET+$? ))
-	done
+      eval set +A dm_liste \${${2}}
+    else
+      dm_liste=${1}
+    fi
+    eval DEST=\${${#}}
+
+        # test if the (first) file is present in the old computation :
+    IGCM_sys_TestFileArchive ${dm_liste[0]}
+    RET=$?
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Get, ERROR : regular file ${dm_liste[0]} DOES NOT EXIST ."
+      IGCM_debug_Exit "IGCM_sys_Get"
+            #return
+    fi
+
+    (( RET=0 ))
+    for target in ${dm_liste[*]} ; do
+      \cp ${target} ${DEST} >> out_rsync 2>&1
+      (( RET=RET+$? ))
+    done
 
 #       echo ${RSYNC} ${RSYNC_opt} $@ > out_rsync 2>&1
 #       ${RSYNC} ${RSYNC_opt} $@ >> out_rsync 2>&1
-# 	RET=$?
-# 	IGCM_sys_Rsync_out $RET
-
-#  	${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
-#  	(( RET=RET+$? ))
-
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Get : copy error."
-	    cat out_rsync
-	    IGCM_debug_Exit "IGCM_sys_Get"
-	else
-	    \rm out_rsync
-	fi
+#       RET=$?
+#       IGCM_sys_Rsync_out $RET
+
+#       ${libIGCM}/libIGCM_sys/IGCM_analyse_rsync_out.awk out_rsync
+#       (( RET=RET+$? ))
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Get : copy error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_Get"
     else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Get"
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Get"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_GetBuffer
+#D-* Purpose: Get a file from ${SCRATCHDIR}
+#D-* Examples: IGCM_sys_GetBuffer myfile /destpath/myfile_with_PREFIX
+#D-            IGCM_sys_GetBuffer /l Array_contain_myfiles /destpath/
+function IGCM_sys_GetBuffer {
+  IGCM_debug_PushStack "IGCM_sys_GetBuffer" $@
+
+  typeset DEST RET buf_liste ifile target file_work
+
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_GetBuffer :" $@
+  fi
+  if [ $DRYRUN -le 2 ]; then
+    if [ X${1} = X'/l' ] ; then
+      # test if the first file is present in the old computation :
+      eval set +A buf_liste \${${2}}
+    else
+      eval set +A buf_liste ${1}
+    fi
+    eval DEST=\${${#}}
+
+    #USUAL WAY
+    if [ X${1} = X'/l' ] ; then
+      (( RET=0 ))
+      for target in ${buf_liste[*]} ; do
+        local_file=$( basename ${target} )
+        \cp ${target} ${DEST}/${local_file} >> out_rsync 2>&1
+        (( RET = RET + $? ))
+      done
+    else
+      \cp ${buf_liste} ${DEST} >> out_rsync 2>&1
+      RET=$?
+    fi
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_GetBuffer : copy error."
+      cat out_rsync
+      IGCM_debug_Exit "IGCM_sys_GetBuffer"
+    else
+      \rm out_rsync
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_GetBuffer"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_GetDate_FichWork
+#D-* Purpose: donne la date filesys d'un fichier sur le filesystem WORK
+#D-* Examples:
+#D-
+function IGCM_sys_GetDate_FichWork {
+  IGCM_debug_PushStack "IGCM_sys_FichWork" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_GetDate_FichWork :" $@
+  fi
+  typeset dateF
+  set +A dateF -- $( ls -l --full-time --time-style='+%Y%m%d%H%M%S' ${1} )
+  eval ${2}=${dateF[5]}
+
+    # donne la date filesys d'un fichier sur la machine work
+  IGCM_debug_PopStack "IGCM_sys_FichWork"
+}
+
+#D-#==================================================
+#D-function IGCM_sys_GetDate_FichArchive
+#D-* Purpose: donne la date filesys d'un fichier sur le filesystem ARCHIVE
+#D-* Examples:
+#D-
+function IGCM_sys_GetDate_FichArchive {
+  IGCM_debug_PushStack "IGCM_sys_FichArchive" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_GetDate_FichArchive :" $@
+  fi
+  typeset dateF
+  set +A dateF -- $( ls -l --full-time --time-style='+%Y%m%d%H%M%S' ${1} )
+  eval ${2}=${dateF[5]}
+
+  IGCM_debug_PopStack "IGCM_sys_FichArchive"
 }
 
@@ -1016,29 +1246,8 @@
 #D-
 function IGCM_sys_Dods_Rm {
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Dods_Rm :" $@
-    fi
-    typeset RET
-    RET=0
-    if [ $DRYRUN = 0 ]; then
-	if [ ! -d /dmnfs/cont003/dods/public/${LOGIN}/${R_DODS}/${1} ] ; then
-	    echo "WARNING : IGCM_sys_Dods_Rm /dmnfs/cont003/dods/public/${LOGIN}/${R_DODS}/${1} DOES NOT EXIST ."
-	    echo "Nothing has been done."
-	    return
-	fi
- 	IGCM_sys_Rm -Rf /tmp/DODS/${config_UserChoices_TagName}/${config_UserChoices_JobName}/${1}
-	RET=$?
-        
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Put_Dods : error."
-	    cat out_dods_rm
-	    IGCM_debug_Exit "IGCM_sys_Dods_Rm"
-	else
-	    rm out_dods_rm
-	fi
-    else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    return $RET
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Dods_Rm :" $@
+  fi
+  return 0
 }
 
@@ -1050,31 +1259,8 @@
 #D-
 function IGCM_sys_Dods_Cp {
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Dods_Cp :" $@
-    fi
-    typeset RET
-    RET=0
-    if [ $DRYRUN = 0 ]; then
-	if [ ! -d ${R_SAVE}/${1} ] ; then
-	    echo "WARNING : IGCM_sys_Dods_Cp ${R_SAVE}/${1} DOES NOT EXIST ."
-	    echo "Nothing has been done."
-	    return
-	fi
-	#
- 	IGCM_sys_Mkdir /tmp/DODS/${config_UserChoices_TagName}/${config_UserChoices_JobName}
- 	IGCM_sys_Cp -Rp --parents ${1} /tmp/DODS/${config_UserChoices_TagName}/${config_UserChoices_JobName}
-	RET=$?
-        
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Dods_Cp : error."
-	    cat out_dods_cp
-	    IGCM_debug_Exit "IGCM_sys_Dods_Cp"
-	else
-	    rm out_dods_cp
-	fi
-    else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    return $RET
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Dods_Cp :" $@
+  fi
+  return 0
 }
 
@@ -1085,59 +1271,19 @@
 #D-
 function IGCM_sys_Put_Dods {
-    IGCM_debug_PushStack "IGCM_sys_Put_Dods" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_Put_Dods :" $@
-    fi
-    if [ $DRYRUN = 0 ]; then
-	if [ ! -d ${R_SAVE}/${1} ] ; then
-	    echo "WARNING : IGCM_sys_Put_Dods ${R_SAVE}/${1} DOES NOT EXIST ."
-	    IGCM_debug_PopStack "IGCM_sys_Put_Dods"
-	    return
-	fi
-
-	typeset RET
-	#
- 	cd ${R_SAVE}
-	IGCM_sys_Dods_Rm ${1}
-	IGCM_sys_Dods_Cp ${1}
-	RET=0
-        
-	if [ ${RET} -gt 0 ] ; then
-	    echo "IGCM_sys_Put_Dods : error."
-	    IGCM_debug_Exit "IGCM_sys_Put_Dods"
-	fi
-    else
-	( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
-    fi
-    IGCM_debug_PopStack "IGCM_sys_Put_Dods"
-}
-
-############################################################## A FINIR !!
-
-#D-#==================================================
-#D-function IGCM_sys_GetDate_FichWork
-#D-* Purpose: donne la date filesys d'un fichier sur le filesystem WORK
-#D-* Examples:
-#D-
-function IGCM_sys_GetDate_FichWork {
-    IGCM_debug_PushStack "IGCM_sys_FichWork" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_GetDate_FichWork :" $@
-    fi
-    # donne la date filesys d'un fichier sur la machine work
-    IGCM_debug_PopStack "IGCM_sys_FichWork"
-}
-
-#D-#==================================================
-#D-function IGCM_sys_GetDate_FichArchive
-#D-* Purpose: donne la date filesys d'un fichier sur le filesystem ARCHIVE 
-#D-* Examples:
-#D-
-function IGCM_sys_GetDate_FichArchive {
-    IGCM_debug_PushStack "IGCM_sys_FichArchive" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_GetDate_FichArchive :" $@
-    fi
-    IGCM_debug_PopStack "IGCM_sys_FichArchive"
+  IGCM_debug_PushStack "IGCM_sys_Put_Dods" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_Put_Dods :" $@
+  fi
+  if [ $DRYRUN = 0 ]; then
+    RET=0
+
+    if [ ${RET} -gt 0 ] ; then
+      echo "IGCM_sys_Put_Dods : error."
+      IGCM_debug_Exit "IGCM_sys_Put_Dods"
+    fi
+  else
+    ( ${DEBUG_debug} ) && echo "DRYRUN mode = " $DRYRUN >> stack
+  fi
+  IGCM_debug_PopStack "IGCM_sys_Put_Dods"
 }
 
@@ -1146,219 +1292,15 @@
 
 function IGCM_sys_rebuild {
-    IGCM_debug_PushStack "IGCM_sys_rebuild" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_rebuild :" $@
-    fi
-    rebuild -f -o $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_rebuild : erreur ${@}."
-       IGCM_debug_Exit "rebuild"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_rebuild"
-}
-
-##############################################################
-# NCO OPERATOR
-
-function IGCM_sys_ncap2 {
-    IGCM_debug_PushStack "IGCM_sys_ncap2" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncap2 :" $@
-    fi
-    /usr/local/bin/ncap2 "$@"
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncap2 : erreur ${@}."
-       IGCM_debug_Exit "ncap2"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncap2"
-}
-
-function IGCM_sys_ncatted {
-    IGCM_debug_PushStack "IGCM_sys_ncatted" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncatted :" $@
-    fi
-    /usr/local/bin/ncatted "$@"
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncatted : erreur ${@}."
-       IGCM_debug_Exit "ncatted"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncatted"
-}
-
-function IGCM_sys_ncbo {
-    IGCM_debug_PushStack "IGCM_sys_ncbo" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncbo :" $@
-    fi
-    /usr/local/bin/ncbo $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncbo : erreur ${@}."
-       IGCM_debug_Exit "ncbo"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncbo"
-}
-
-function IGCM_sys_ncdiff {
-    IGCM_debug_PushStack "IGCM_sys_ncdiff" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncdiff :" $@
-    fi
-    /usr/local/bin/ncdiff $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncdiff : erreur ${@}."
-       IGCM_debug_Exit "ncdiff"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncdiff"
-}
-
-function IGCM_sys_ncea {
-    IGCM_debug_PushStack "IGCM_sys_ncea" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncea :" $@
-    fi
-    /usr/local/bin/ncea $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncea : erreur ${@}."
-       IGCM_debug_Exit "ncea"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncea"
-}
-
-function IGCM_sys_ncecat {
-    IGCM_debug_PushStack "IGCM_sys_ncecat" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncecat :" $@
-    fi
-    /usr/local/bin/ncecat $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncecat : erreur ${@}."
-       IGCM_debug_Exit "ncecat"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncecat"
-}
-
-function IGCM_sys_ncflint {
-    IGCM_debug_PushStack "IGCM_sys_ncflint" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncflint :" $@
-    fi
-    /usr/local/bin/ncflint $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncflint : erreur ${@}."
-       IGCM_debug_Exit "ncflint"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncflint"
-}
-
-function IGCM_sys_ncks {
-    IGCM_debug_PushStack "IGCM_sys_ncks" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncks :" $@
-    fi
-    /usr/local/bin/ncks $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncks : erreur ${@}."
-       IGCM_debug_Exit "ncks"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncks"
-}
-
-function IGCM_sys_ncpdq {
-    IGCM_debug_PushStack "IGCM_sys_ncpdq" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncpdq :" $@
-    fi
-    /usr/local/bin/ncpdq $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncpdq : erreur ${@}."
-       IGCM_debug_Exit "ncpdq"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncpdq"
-}
-
-function IGCM_sys_ncra {
-    IGCM_debug_PushStack "IGCM_sys_ncra" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncra :" $@
-    fi
-    /usr/local/bin/ncra $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncra : erreur ${@}."
-       IGCM_debug_Exit "ncra"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncra"
-}
-
-function IGCM_sys_ncrcat {
-    IGCM_debug_PushStack "IGCM_sys_ncrcat" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncrcat :" $@
-    fi
-    /usr/local/bin/ncrcat $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncrcat : erreur ${@}."
-#       IGCM_debug_Exit "ncrcat"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncrcat"
-}
-
-function IGCM_sys_ncrename {
-    IGCM_debug_PushStack "IGCM_sys_ncrename" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncrename :" $@
-    fi
-    /usr/local/bin/ncrename $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncrename : erreur ${@}."
-       IGCM_debug_Exit "ncrename"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncrename"
-}
-
-function IGCM_sys_ncwa {
-    IGCM_debug_PushStack "IGCM_sys_ncwa" -- $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_ncwa :" $@
-    fi
-    /usr/local/bin/ncwa $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_ncwa : erreur ${@}."
-       IGCM_debug_Exit "ncwa"
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_ncwa"
-}
-
-##############################################################
-# CDO OPERATOR
-
-function IGCM_sys_cdo {
-    IGCM_debug_PushStack "IGCM_sys_cdo" -- $@
-
-    \cdo $@
-    if [ $? -gt 0 ] ; then
-       echo "IGCM_sys_cdo : erreur ${@}."
-       IGCM_debug_PopStack "IGCM_sys_cdo"
-       return 1
-    else
-	IGCM_debug_PopStack "IGCM_sys_cdo"
-	return 0
-    fi
-
-    IGCM_debug_PopStack "IGCM_sys_cdo"
+  IGCM_debug_PushStack "IGCM_sys_rebuild" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_rebuild :" $@
+  fi
+  rebuild -f -o $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_rebuild : erreur ${@}."
+    IGCM_debug_Exit "rebuild"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_rebuild"
 }
 
@@ -1367,9 +1309,9 @@
 
 function IGCM_sys_activ_variables {
-    IGCM_debug_PushStack "IGCM_sys_activ_variables"
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_activ_variables"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_activ_variables"
+  IGCM_debug_PushStack "IGCM_sys_activ_variables"
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_activ_variables"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_activ_variables"
 }
 
@@ -1378,9 +1320,9 @@
 
 function IGCM_sys_desactiv_variables {
-    IGCM_debug_PushStack "IGCM_sys_desactiv_variables"
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_desactiv_variables"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_desactiv_variables"
+  IGCM_debug_PushStack "IGCM_sys_desactiv_variables"
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_desactiv_variables"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_desactiv_variables"
 }
 
@@ -1389,9 +1331,267 @@
 
 function IGCM_sys_build_run_file {
-    IGCM_debug_PushStack "IGCM_sys_build_run_file" $@
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_build_run_file" $@
-    fi
-    IGCM_debug_PopStack "IGCM_sys_build_run_file"
+
+  IGCM_debug_Print 3 " dummy function : IGCM_sys_build_run_file "
+
+}
+
+############################################################
+# Build MPI/OMP scripts
+function IGCM_sys_build_execution_scripts
+{
+  IGCM_debug_PushStack "IGCM_sys_build_execution_scripts" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_build_execution_scripts " $@
+  fi
+  typeset nodes listnodes init_node start_num init_exec comp ExeNameIn ExeNameOut
+  typeset node_num_current node_current comp_proc_mpi_loc comp_proc_omp_loc
+  typeset num_corempi nombre_restant_node nombre_restant_comp
+
+  if [ ! -f ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} ]  ; then
+    IGCM_debug_Exit "IGCM_sys_titane build_execution_scripts : Job_${config_UserChoices_JobName} doesn't exist in SUBMIT_DIR : ${SUBMIT_DIR} "
+  fi
+
+  if ( ${OK_PARA_MPMD} ) ; then
+
+    if [ -f run_file ] ; then
+      IGCM_sys_Rm -f run_file
+    fi
+    touch run_file
+
+    if ( ${OK_PARA_OMP} ) ; then
+
+      #  Hosts treatment
+
+      ${HOST_MPIRUN_COMMAND} hostname | sort | uniq > hosts.tmp
+
+      i=0
+      rm -f hosts
+      IGCM_debug_Print 1 "sys $( hostname ), Hosts avaible :"
+      for nodes in `cat hosts.tmp` ; do
+        host[$i]=$nodes
+        echo "${host[$i]} slots=1 max_slots=1" >> hosts
+        IGCM_debug_Print 1 ${host[$i]}
+        i=$((i+1))
+      done
+      rm -f hosts.tmp
+
+      listnodes=${host[*]}
+
+      EXECUTION="${HOST_MPIRUN_COMMAND} -hostfile hosts"
+
+      # Initialisation
+
+      init_node=y
+      node_num_current=0
+      start_num=0
+      init_exec=n
+
+      # Test : if oasis is there, we put it at the first position
+
+      for comp in ${config_ListOfComponents[*]} ; do
+
+        if [ "X${comp}" = "XCPL" ]  ; then
+
+          eval ExeNameIn=\${config_Executable_${comp}[0]}
+          eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+          echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
+          echo ""  >> script_${ExeNameOut}.ksh
+          #echo "export KMP_STACKSIZE=3g"  >> script_${ExeNameOut}.ksh
+          #echo "export KMP_LIBRARY=turnaround"  >> script_${ExeNameOut}.ksh
+          #echo "export MKL_SERIAL=YES"  >> script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut} > out_${ExeNameOut}.out 2>out_${ExeNameOut}.err"  >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+
+          init_node=n
+
+          (( nombre_restant_node = NUM_COREPERNODE - 1 ))
+          node_num_current=0
+          node_current=${host[${node_num_current}]}
+
+          EXECUTION="${EXECUTION} -H ${node_current} -np 1 ./script_${ExeNameOut}.ksh"
+
+          init_exec=y
+          start_num=1
+
+        fi
+
+      done
+
+      # Then loop on the components (except for oasis)
+
+      for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameIn=\${config_Executable_${comp}[0]}
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+        # Only if we really have an executable for the component :
+        if ( [ "X${ExeNameOut}" != X\"\" ] &&  [ "X${comp}" != "XCPL" ] ) ; then
+
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+          eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+
+          echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
+          # echo "set -vx" >> script_${ExeNameOut}.ksh
+          echo ""  >> script_${ExeNameOut}.ksh
+          #echo "export KMP_STACKSIZE=3g"  >> script_${ExeNameOut}.ksh
+          #echo "export KMP_LIBRARY=turnaround"  >> script_${ExeNameOut}.ksh
+          #echo "export MKL_SERIAL=YES"  >> script_${ExeNameOut}.ksh
+          echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh
+          echo "(( MYMPIRANK = OMPI_COMM_WORLD_RANK - ${start_num})) " >>  script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${MYMPIRANK} 2>out_${ExeNameOut}.err.\${MYMPIRANK}"  >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+
+          node_num=0
+
+          # We define the number of MPI process to be assigned for the component
+
+          nombre_restant_comp=${comp_proc_mpi_loc}
+
+          # Loop on the allocated nodes
+
+          for node in ${listnodes} ; do
+
+            # We go to the current node
+            if [ ${node_num} = ${node_num_current} ] ; then
+
+              node_current=${host[${node_num_current}]}
+
+              # If first time on the node : initialisation
+
+              if [ ${init_node} = y ] ; then
+                nombre_restant_node=${NUM_COREPERNODE}
+              fi
+
+              # Test on the number of OMP threads
+
+              if [ ${comp_proc_omp_loc} -gt ${nombre_restant_node} ] ; then
+                (( node_num = node_num + 1 ))
+                node_num_current=${node_num}
+                init_node=y
+                continue
+              fi
+
+              # Number of MPI process to assign
+
+              (( num_corempi = nombre_restant_node / comp_proc_omp_loc ))
+
+              if [ ${num_corempi} -gt ${nombre_restant_comp} ] ; then
+                num_corempi=${nombre_restant_comp}
+              fi
+
+              (( nombre_restant_node = nombre_restant_node - num_corempi * comp_proc_omp_loc ))
+              (( nombre_restant_comp = nombre_restant_comp - num_corempi ))
+
+              if [ ${init_exec} = y ] ; then
+                EXECUTION="${EXECUTION} : -H ${node_current} -np ${num_corempi} ./script_${ExeNameOut}.ksh"
+              else
+                EXECUTION="${EXECUTION} -H ${node_current} -np ${num_corempi} ./script_${ExeNameOut}.ksh"
+                init_exec=y
+              fi
+
+              ((  start_num = num_corempi + start_num ))
+
+            else
+
+              (( node_num = node_num + 1 ))
+              continue
+            fi
+
+            # Test on the number of core/process remaining on the node/component
+
+            if [ ${nombre_restant_node} = 0 ] ; then
+              (( node_num = node_num + 1 ))
+              node_num_current=${node_num}
+              init_node=y
+
+              if [ ${nombre_restant_comp} = 0 ] ; then
+                break 1
+              fi
+            else
+
+              node_num_current=${node_num}
+              init_node=n
+
+              if [ ${nombre_restant_comp} = 0 ] ; then
+                break 1
+              fi
+            fi
+          done
+        fi
+      done
+
+    else
+
+      # Then first loop on the components for the coupler ie oasis
+
+      ## the coupler ie oasis must be the first one
+      for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+        # for CPL component only
+        if [ "X${comp}" = "XCPL" ] ; then
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+          echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut} " >> run_file
+        fi
+      done
+
+      # Then second loop on the components
+
+      for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+        # Only if we really have an executable for the component and not the coupler ie oasis:
+        if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+          echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file
+        fi
+      done
+      IGCM_sys_Chmod u+x run_file
+
+      EXECUTION="${HOST_MPIRUN_COMMAND} --app ./run_file"
+
+    fi
+
+  else # Only one executable. launch it.
+
+    for comp in ${config_ListOfComponents[*]} ; do
+
+      # Only if we really have an executable for the component :
+      eval ExeNameOut=\${config_Executable_${comp}[1]}
+      if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${ExeNameOut}" != "Xinca.dat" ] ) ; then
+
+        echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
+        echo ""  >> script_${ExeNameOut}.ksh
+        if ( ${OK_PARA_OMP} ) ; then
+          eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+          echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh
+        fi
+        if  ( ${OK_PARA_MPI} ) ; then
+          # Default : mpirun used if nb_proc gt 1
+          # pour sortie out/err par process
+          # echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${OMPI_COMM_WORLD_RANK} 2>out_${ExeNameOut}.err.\${OMPI_COMM_WORLD_RANK}"  >> script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut}" >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+          EXECUTION="${HOST_MPIRUN_COMMAND} ./script_${ExeNameOut}.ksh"
+        else
+          # Default : mpirun is NOT used if nb_proc eq 1
+          # pour sortie out/err par process
+          # echo "./${ExeNameOut} > out_${ExeNameOut}.out 2>out_${ExeNameOut}.err" >> script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut}" >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+          EXECUTION="time ./script_${ExeNameOut}.ksh"
+        fi
+      fi
+    done
+
+  fi
+
+  IGCM_debug_Print 1 "sys $( hostname ) : La commande d execution est "
+  IGCM_debug_Print 1 $EXECUTION
+
+  IGCM_debug_PopStack "IGCM_sys_build_execution_scripts"
 }
 
@@ -1399,8 +1599,212 @@
 # Check of space available on temporary filesytems
 function IGCM_sys_check_quota {
-    IGCM_debug_PushStack "IGCM_sys_check_quota"
-    if ( $DEBUG_sys ) ; then
-	echo "IGCM_sys_check_quota"
-    fi
-    IGCM_debug_PopStack "IGCM_sys_check_quota"
-}
+  IGCM_debug_PushStack "IGCM_sys_check_quota"
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_check_quota"
+  fi
+  IGCM_debug_PopStack "IGCM_sys_check_quota"
+}
+
+##############################################################
+# NCO OPERATOR
+
+function IGCM_sys_ncap2 {
+  IGCM_debug_PushStack "IGCM_sys_ncap2" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncap2 :" $@
+  fi
+  /usr/local/bin/ncap2 "$@"
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncap2 : erreur ${@}."
+    IGCM_debug_Exit "ncap2"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncap2"
+}
+
+function IGCM_sys_ncatted {
+  IGCM_debug_PushStack "IGCM_sys_ncatted" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncatted :" $@
+  fi
+  /usr/local/bin/ncatted "$@"
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncatted : erreur ${@}."
+    IGCM_debug_Exit "ncatted"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncatted"
+}
+
+function IGCM_sys_ncbo {
+  IGCM_debug_PushStack "IGCM_sys_ncbo" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncbo :" $@
+  fi
+  /usr/local/bin/ncbo $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncbo : erreur ${@}."
+    IGCM_debug_Exit "ncbo"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncbo"
+}
+
+function IGCM_sys_ncdiff {
+  IGCM_debug_PushStack "IGCM_sys_ncdiff" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncdiff :" $@
+  fi
+  /usr/local/bin/ncdiff $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncdiff : erreur ${@}."
+    IGCM_debug_Exit "ncdiff"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncdiff"
+}
+
+function IGCM_sys_ncea {
+  IGCM_debug_PushStack "IGCM_sys_ncea" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncea :" $@
+  fi
+  /usr/local/bin/ncea $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncea : erreur ${@}."
+    IGCM_debug_Exit "ncea"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncea"
+}
+
+function IGCM_sys_ncecat {
+  IGCM_debug_PushStack "IGCM_sys_ncecat" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncecat :" $@
+  fi
+  /usr/local/bin/ncecat $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncecat : erreur ${@}."
+    IGCM_debug_Exit "ncecat"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncecat"
+}
+
+function IGCM_sys_ncflint {
+  IGCM_debug_PushStack "IGCM_sys_ncflint" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncflint :" $@
+  fi
+  /usr/local/bin/ncflint $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncflint : erreur ${@}."
+    IGCM_debug_Exit "ncflint"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncflint"
+}
+
+function IGCM_sys_ncks {
+  IGCM_debug_PushStack "IGCM_sys_ncks" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncks :" $@
+  fi
+  /usr/local/bin/ncks $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncks : erreur ${@}."
+    IGCM_debug_Exit "ncks"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncks"
+}
+
+function IGCM_sys_ncpdq {
+  IGCM_debug_PushStack "IGCM_sys_ncpdq" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncpdq :" $@
+  fi
+  /usr/local/bin/ncpdq $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncpdq : erreur ${@}."
+    IGCM_debug_Exit "ncpdq"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncpdq"
+}
+
+function IGCM_sys_ncra {
+  IGCM_debug_PushStack "IGCM_sys_ncra" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncra :" $@
+  fi
+  /usr/local/bin/ncra $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncra : erreur ${@}."
+    IGCM_debug_Exit "ncra"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncra"
+}
+
+function IGCM_sys_ncrcat {
+  IGCM_debug_PushStack "IGCM_sys_ncrcat" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncrcat :" $@
+  fi
+  /usr/local/bin/ncrcat $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncrcat : erreur ${@}."
+#       IGCM_debug_Exit "ncrcat"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncrcat"
+}
+
+function IGCM_sys_ncrename {
+  IGCM_debug_PushStack "IGCM_sys_ncrename" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncrename :" $@
+  fi
+  /usr/local/bin/ncrename $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncrename : erreur ${@}."
+    IGCM_debug_Exit "ncrename"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncrename"
+}
+
+function IGCM_sys_ncwa {
+  IGCM_debug_PushStack "IGCM_sys_ncwa" -- $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_ncwa :" $@
+  fi
+  /usr/local/bin/ncwa $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_ncwa : erreur ${@}."
+    IGCM_debug_Exit "ncwa"
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_ncwa"
+}
+
+##############################################################
+# CDO OPERATOR
+
+function IGCM_sys_cdo {
+  IGCM_debug_PushStack "IGCM_sys_cdo" -- $@
+
+  \cdo $@
+  if [ $? -gt 0 ] ; then
+    echo "IGCM_sys_cdo : erreur ${@}."
+    IGCM_debug_PopStack "IGCM_sys_cdo"
+    return 1
+  else
+    IGCM_debug_PopStack "IGCM_sys_cdo"
+    return 0
+  fi
+
+  IGCM_debug_PopStack "IGCM_sys_cdo"
+}
Index: trunk/libIGCM/libIGCM_sys/libIGCM_sys_mercurex9.ksh
===================================================================
--- trunk/libIGCM/libIGCM_sys/libIGCM_sys_mercurex9.ksh	(revision 663)
+++ trunk/libIGCM/libIGCM_sys/libIGCM_sys_mercurex9.ksh	(revision 664)
@@ -1478,38 +1478,38 @@
 function IGCM_sys_build_execution_scripts 
 {
-    IGCM_debug_PushStack "IGCM_sys_build_execution_scripts" $@
-    if ( $DEBUG_sys ) ; then
-        echo "IGCM_sys_build_execution_scripts " $@
-    fi
-
-    typeset NbNodes_Job NbProc_Job comp_proc_mpi_loc comp_proc_omp_loc mpi_count
-    
-    if [ ! -f ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} ]  ; then
-        IGCM_debug_Exit "IGCM_sys_mercurex9 build_execution_scripts : Job_${config_UserChoices_JobName} don't exist in SUBMIT_DIR : ${SUBMIT_DIR} "
-    fi
-
-    if ( ${OK_PARA_MPMD} ) ; then
-
-        if [ -f run_file ] ; then
-            IGCM_sys_Rm -f run_file
-        fi
-        touch run_file
-
-	if ( ${OK_PARA_OMP} ) ; then
-		IGCM_debug_Print 2 "Error in config.card on SX9 : OpenMP not available"
-		exit 1
-	else
+  IGCM_debug_PushStack "IGCM_sys_build_execution_scripts" $@
+  if ( $DEBUG_sys ) ; then
+    echo "IGCM_sys_build_execution_scripts " $@
+  fi
+
+  typeset NbNodes_Job NbProc_Job comp_proc_mpi_loc comp_proc_omp_loc mpi_count
+  
+  if [ ! -f ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} ]  ; then
+    IGCM_debug_Exit "IGCM_sys_mercurex9 build_execution_scripts : Job_${config_UserChoices_JobName} don't exist in SUBMIT_DIR : ${SUBMIT_DIR} "
+  fi
+
+  if ( ${OK_PARA_MPMD} ) ; then
+
+    if [ -f run_file ] ; then
+      IGCM_sys_Rm -f run_file
+    fi
+    touch run_file
+
+    if ( ${OK_PARA_OMP} ) ; then
+      IGCM_debug_Print 2 "Error in config.card on SX9 : OpenMP not available"
+      exit 1
+    else
 # OLD :
 #PBS -v BATCH_NUM_PROC_TOT=4
 #PBS -l cpunum_job=${BATCH_NUM_PROC_TOT}
-	    echo "Job_${config_UserChoices_JobName} includes BATCH_NUM_PROC_TOT = \c"
-	    cat ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} | grep -- "-v *BATCH_NUM_PROC_TOT" | sed -e "s/.*BATCH_NUM_PROC_TOT *= *//" 
-	    NbProc_Job=$( cat ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} | grep -- "-v *BATCH_NUM_PROC_TOT" | sed -e "s/.*BATCH_NUM_PROC_TOT *= *//" )
-	    NbProc_Job=${NbProc_Job:=0}
-	    if [ ${NbProc_Job} -eq 0 ] ; then
-		IGCM_debug_Print 2 "Error in Job_${config_UserChoices_JobName} ressources : no BATCH_NUM_PROC_TOT defined with MPI only run."
-		exit 1
-	    fi
-	fi
+      echo "Job_${config_UserChoices_JobName} includes BATCH_NUM_PROC_TOT = \c"
+      cat ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} | grep -- "-v *BATCH_NUM_PROC_TOT" | sed -e "s/.*BATCH_NUM_PROC_TOT *= *//" 
+      NbProc_Job=$( cat ${SUBMIT_DIR}/Job_${config_UserChoices_JobName} | grep -- "-v *BATCH_NUM_PROC_TOT" | sed -e "s/.*BATCH_NUM_PROC_TOT *= *//" )
+      NbProc_Job=${NbProc_Job:=0}
+      if [ ${NbProc_Job} -eq 0 ] ; then
+	IGCM_debug_Print 2 "Error in Job_${config_UserChoices_JobName} ressources : no BATCH_NUM_PROC_TOT defined with MPI only run."
+	exit 1
+      fi
+    fi
 
 # run_file construction
@@ -1519,18 +1519,18 @@
 ### the coupler ie oasis must be the first one
     for comp in ${config_ListOfComponents[*]} ; do
+      
+      eval ExeNameIn=\${config_Executable_${comp}[0]}
+      eval ExeNameOut=\${config_Executable_${comp}[1]}
+      
+      # for CPL component only
+      if [ "X${comp}" = "XCPL" ] ; then
+
+	eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+	eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
 	
-	eval ExeNameIn=\${config_Executable_${comp}[0]}
-	eval ExeNameOut=\${config_Executable_${comp}[1]}
-	    
-	# for CPL component only
-	if [ "X${comp}" = "XCPL" ] ; then
-
-	    eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
-	    eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
-	    
-	    if ( ${OK_PARA_MPI} ) ; then 
-	        echo "-p ${comp_proc_mpi_loc} -e ./${ExeNameOut}" >> run_file 
-	    fi
+	if ( ${OK_PARA_MPI} ) ; then 
+	  echo "-p ${comp_proc_mpi_loc} -e ./${ExeNameOut}" >> run_file 
 	fi
+      fi
     done
 
@@ -1538,18 +1538,18 @@
 
     for comp in ${config_ListOfComponents[*]} ; do
+      
+      eval ExeNameIn=\${config_Executable_${comp}[0]}
+      eval ExeNameOut=\${config_Executable_${comp}[1]}
+      
+      # Only if we really have an executable for the component and not the coupler ie oasis:
+      if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
+
+	eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+	eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
 	
-	eval ExeNameIn=\${config_Executable_${comp}[0]}
-	eval ExeNameOut=\${config_Executable_${comp}[1]}
-	    
-	# Only if we really have an executable for the component and not the coupler ie oasis:
-	if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
-
-	    eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
-	    eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
-	    
-	    if ( ${OK_PARA_MPI} ) ; then 
-		    echo "-p ${comp_proc_mpi_loc} -e ./${ExeNameOut}" >> run_file 
-	    fi
+	if ( ${OK_PARA_MPI} ) ; then 
+	  echo "-p ${comp_proc_mpi_loc} -e ./${ExeNameOut}" >> run_file 
 	fi
+      fi
     done
 
@@ -1562,21 +1562,22 @@
     fi
 
-else # Only one executable. launch it.
+  else # Only one executable. launch it.
 
     for comp in ${config_ListOfComponents[*]} ; do
 
-        eval ExeNameIn=\${config_Executable_${comp}[0]}
-        eval ExeNameOut=\${config_Executable_${comp}[1]}
-
-	[ "X${ExeNameOut}" != X\"\" ] &&  EXECUTION="time mpirun -np ${BATCH_NUM_PROC_TOT} ./${ExeNameOut}"
-
+      eval ExeNameIn=\${config_Executable_${comp}[0]}
+      eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+      if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${ExeNameOut}" != "Xinca.dat" ] ) ; then
+        EXECUTION="time mpirun -np ${BATCH_NUM_PROC_TOT} ./${ExeNameOut}"
+      fi
     done
 
-fi
-
-    IGCM_debug_Print 1 "sys mercurex9 : execution command is "
-    IGCM_debug_Print 1 "$EXECUTION"
-
-    IGCM_debug_PopStack "IGCM_sys_build_execution_scripts"
+  fi
+
+  IGCM_debug_Print 1 "sys mercurex9 : execution command is "
+  IGCM_debug_Print 1 "$EXECUTION"
+
+  IGCM_debug_PopStack "IGCM_sys_build_execution_scripts"
 
 }
@@ -1592,4 +1593,5 @@
 function IGCM_sys_check_quota {
   IGCM_debug_PushStack "IGCM_sys_check_quota" 
+
   if ( $DEBUG_sys ) ; then
     echo "IGCM_sys_check_quota "
Index: trunk/libIGCM/libIGCM_sys/libIGCM_sys_obelix.ksh
===================================================================
--- trunk/libIGCM/libIGCM_sys/libIGCM_sys_obelix.ksh	(revision 663)
+++ trunk/libIGCM/libIGCM_sys/libIGCM_sys_obelix.ksh	(revision 664)
@@ -201,6 +201,5 @@
 function IGCM_sys_RshMaster {
   IGCM_debug_PushStack "IGCM_sys_RshMaster" $@
-
-  ssh obelix3 exec /bin/ksh  <<-EOF
+  ssh obelix3 /bin/ksh  <<-EOF
     export libIGCM=${libIGCM}
     export DEBUG_debug=${DEBUG_debug}
@@ -272,7 +271,7 @@
 Dear ${LOGIN},
 
-  Simulation ${config_UserChoices_JobName} ${status} on supercomputer `hostname`.
-  Job started : ${PeriodDateBegin}
-  Job ended   : ${PeriodDateEnd}
+  Simulation ${config_UserChoices_JobName} is ${status} on supercomputer `hostname`.
+  Job started : ${DateBegin}
+  Job ended   : ${DateEnd}
   Output files are available in ${R_SAVE}
   Script files, Script Outputs and Debug files (if necessary) are available in ${SUBMIT_DIR}
@@ -1354,5 +1353,5 @@
 function IGCM_sys_build_run_file {
 
-IGCM_debug_Print 3 " dummy function : IGCM_sys_build_run_file "
+  IGCM_debug_Print 3 " dummy function : IGCM_sys_build_run_file "
 
 }
@@ -1546,33 +1545,33 @@
     else
 
-        # Then first loop on the components for the coupler ie oasis
-
-        ## the coupler ie oasis must be the first one
-        for comp in ${config_ListOfComponents[*]} ; do
-
-            eval ExeNameOut=\${config_Executable_${comp}[1]}
+      # Then first loop on the components for the coupler ie oasis
+
+      ## the coupler ie oasis must be the first one
+      for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
 
         # for CPL component only
-            if [ "X${comp}" = "XCPL" ] ; then
-                eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
-                echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut} " >> run_file
-            fi
-        done
+        if [ "X${comp}" = "XCPL" ] ; then
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+          echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut} " >> run_file
+        fi
+      done
 
         # Then second loop on the components
 
-        for comp in ${config_ListOfComponents[*]} ; do
-
-            eval ExeNameOut=\${config_Executable_${comp}[1]}
-
-            # Only if we really have an executable for the component and not the coupler ie oasis:
-            if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
-                eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
-                echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file
-            fi
-        done
-        IGCM_sys_Chmod u+x run_file
-
-        EXECUTION="${HOST_MPIRUN_COMMAND} --app ./run_file"
+      for comp in ${config_ListOfComponents[*]} ; do
+
+        eval ExeNameOut=\${config_Executable_${comp}[1]}
+
+        # Only if we really have an executable for the component and not the coupler ie oasis:
+        if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${comp}" != "XCPL" ] ) ; then
+          eval comp_proc_mpi_loc=\${${comp}_PROC_MPI}
+          echo "-np ${comp_proc_mpi_loc} ./${ExeNameOut}" >> run_file
+        fi
+      done
+      IGCM_sys_Chmod u+x run_file
+
+      EXECUTION="${HOST_MPIRUN_COMMAND} --app ./run_file"
 
     fi
@@ -1580,33 +1579,33 @@
   else # Only one executable. launch it.
 
-      for comp in ${config_ListOfComponents[*]} ; do
-
-          # Only if we really have an executable for the component :
-          eval ExeNameOut=\${config_Executable_${comp}[1]}
-          if ( [ "X${ExeNameOut}" != X\"\" ] ) ; then
-
-              echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
-              echo ""  >> script_${ExeNameOut}.ksh
-              if ( ${OK_PARA_OMP} ) ; then
-                  eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
-                  echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh
-              fi
-              if  ( ${OK_PARA_MPI} ) ; then
-                  # Default : mpirun used if nb_proc gt 1
-                  # pour sortie out/err par process
-                  # echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${OMPI_COMM_WORLD_RANK} 2>out_${ExeNameOut}.err.\${OMPI_COMM_WORLD_RANK}"  >> script_${ExeNameOut}.ksh
-                  echo "./${ExeNameOut}" >> script_${ExeNameOut}.ksh
-                  IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
-                  EXECUTION="${HOST_MPIRUN_COMMAND} ./script_${ExeNameOut}.ksh"
-              else
-                  # Default : mpirun is NOT used if nb_proc eq 1
-                  # pour sortie out/err par process
-                  # echo "./${ExeNameOut} > out_${ExeNameOut}.out 2>out_${ExeNameOut}.err" >> script_${ExeNameOut}.ksh
-                  echo "./${ExeNameOut}" >> script_${ExeNameOut}.ksh
-                  IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
-                  EXECUTION="time ./script_${ExeNameOut}.ksh"
-              fi
-          fi
-      done
+    for comp in ${config_ListOfComponents[*]} ; do
+
+      # Only if we really have an executable for the component :
+      eval ExeNameOut=\${config_Executable_${comp}[1]}
+      if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${ExeNameOut}" != "Xinca.dat" ] ) ; then
+
+        echo "#!/bin/ksh" > script_${ExeNameOut}.ksh
+        echo ""  >> script_${ExeNameOut}.ksh
+        if ( ${OK_PARA_OMP} ) ; then
+          eval comp_proc_omp_loc=\${${comp}_PROC_OMP}
+          echo "OMP_NUM_THREADS=${comp_proc_omp_loc}" >> script_${ExeNameOut}.ksh
+        fi
+        if  ( ${OK_PARA_MPI} ) ; then
+          # Default : mpirun used if nb_proc gt 1
+          # pour sortie out/err par process
+          # echo "./${ExeNameOut} > out_${ExeNameOut}.out.\${OMPI_COMM_WORLD_RANK} 2>out_${ExeNameOut}.err.\${OMPI_COMM_WORLD_RANK}"  >> script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut}" >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+          EXECUTION="${HOST_MPIRUN_COMMAND} ./script_${ExeNameOut}.ksh"
+        else
+          # Default : mpirun is NOT used if nb_proc eq 1
+          # pour sortie out/err par process
+          # echo "./${ExeNameOut} > out_${ExeNameOut}.out 2>out_${ExeNameOut}.err" >> script_${ExeNameOut}.ksh
+          echo "./${ExeNameOut}" >> script_${ExeNameOut}.ksh
+          IGCM_sys_Chmod u+x script_${ExeNameOut}.ksh
+          EXECUTION="time ./script_${ExeNameOut}.ksh"
+        fi
+      fi
+    done
 
   fi
Index: trunk/libIGCM/libIGCM_sys/libIGCM_sys_titane.ksh
===================================================================
--- trunk/libIGCM/libIGCM_sys/libIGCM_sys_titane.ksh	(revision 663)
+++ trunk/libIGCM/libIGCM_sys/libIGCM_sys_titane.ksh	(revision 664)
@@ -194,4 +194,6 @@
 PackDefault=true
 
+#====================================================
+#- Number of core per node (max number of OpenMP task)
 NUM_COREPERNODE=8
 
@@ -1934,5 +1936,5 @@
           # Only if we really have an executable for the component :
           eval ExeNameOut=\${config_Executable_${comp}[1]}
-###          if ( [ "X${ExeNameOut}" != X\"\" ] ) ; then
+###       if ( [ "X${ExeNameOut}" != X\"\" ] ) ; then
           if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${ExeNameOut}" != "Xinca.dat" ] ) ; then
 
Index: trunk/libIGCM/libIGCM_sys/libIGCM_sys_vargas.ksh
===================================================================
--- trunk/libIGCM/libIGCM_sys/libIGCM_sys_vargas.ksh	(revision 663)
+++ trunk/libIGCM/libIGCM_sys/libIGCM_sys_vargas.ksh	(revision 664)
@@ -1530,5 +1530,7 @@
       eval ExeNameOut=\${config_Executable_${comp}[1]}
 
-      [ "X${ExeNameOut}" != X\"\" ] &&  EXECUTION="time ./${ExeNameOut}"
+      if ( [ "X${ExeNameOut}" != X\"\" ] && [ "X${ExeNameOut}" != "Xinca.dat" ] ) ; then
+        EXECUTION="time ./${ExeNameOut}"
+      fi
 
     done
